#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_exportfits import exportfits
from taskinit import casalog
from taskinit import xmlpath
class exportfits_pg_:
    __name__ = "exportfits"

    def __init__(self) :
       self.__bases__ = (exportfits_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, imagename=None,fitsimage=None,velocity=None,optical=None,bitpix=None,minpix=None,maxpix=None,overwrite=None,dropstokes=None,stokeslast=None,history=None,dropdeg=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'exportfits'
        myf['taskname'] = 'exportfits'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['imagename'] = imagename = myf['imagename']
            myparams['fitsimage'] = fitsimage = myf['fitsimage']
            myparams['velocity'] = velocity = myf['velocity']
            myparams['optical'] = optical = myf['optical']
            myparams['bitpix'] = bitpix = myf['bitpix']
            myparams['minpix'] = minpix = myf['minpix']
            myparams['maxpix'] = maxpix = myf['maxpix']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['dropstokes'] = dropstokes = myf['dropstokes']
            myparams['stokeslast'] = stokeslast = myf['stokeslast']
            myparams['history'] = history = myf['history']
            myparams['dropdeg'] = dropdeg = myf['dropdeg']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['fitsimage'] = fitsimage
        mytmp['velocity'] = velocity
        mytmp['optical'] = optical
        mytmp['bitpix'] = bitpix
        mytmp['minpix'] = minpix
        mytmp['maxpix'] = maxpix
        mytmp['overwrite'] = overwrite
        mytmp['dropstokes'] = dropstokes
        mytmp['stokeslast'] = stokeslast
        mytmp['history'] = history
        mytmp['dropdeg'] = dropdeg
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'exportfits.xml')

        casalog.origin('exportfits')
        if not trec.has_key('exportfits') or not casac.utils().verify(mytmp, trec['exportfits']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: exportfits           #####')
          casalog.post('')
          result = exportfits(imagename, fitsimage, velocity, optical, bitpix, minpix, maxpix, overwrite, dropstokes, stokeslast, history, dropdeg)
          casalog.post('')
          casalog.post('##### End Task: exportfits           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('exportfits', 'exportfits.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'exportfits'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass
	casalog.origin('')

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('exportfits', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['imagename']  = ''
        a['fitsimage']  = ''
        a['velocity']  = False
        a['optical']  = False
        a['bitpix']  = -32
        a['minpix']  = 0
        a['maxpix']  = -1
        a['overwrite']  = False
        a['dropstokes']  = False
        a['stokeslast']  = True
        a['history']  = True
        a['dropdeg']  = False


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['imagename']  = ''
        a['fitsimage']  = ''
        a['velocity']  = False
        a['optical']  = False
        a['bitpix']  = -32
        a['minpix']  = 0
        a['maxpix']  = -1
        a['overwrite']  = False
        a['dropstokes']  = False
        a['stokeslast']  = True
        a['history']  = True
        a['dropdeg']  = False

        if a.has_key(paramname) :
	      return a[paramname]
exportfits_pg = exportfits_pg_()
